/* @(#)svc_run.c	2.1 88/07/29 4.0 RPCSRC */

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * This is the rpc server side idle loop
 * Wait for input, call server program.
 */
#include <errno.h>
#include <rpc/rpc.h>
#include "mountd.h"

static int svc_stop = 0;

/* This function can be used as a signal handler to terminate the
   server loop.  */
void
my_svc_exit (void)
{
  svc_stop = 1;
}
int auth_need_reload = 0;

void
my_svc_run (int xfd, void (*handler)(int))
{
  fd_set readfds;

  svc_stop = 0;

  for (;;)
    {
      if (svc_stop)
	return;

      if (auth_need_reload) {
	auth_need_reload = 0;
	auth_reload();
      }

      readfds = svc_fdset;
      
      if (xfd != -1 && handler != NULL)
	FD_SET(xfd, &readfds);
      
      switch (select (FD_SETSIZE, &readfds, (fd_set *)NULL,
			(fd_set *)NULL, (struct timeval *) 0))
	{
	case -1:
	  if (errno == EINTR)
	    {
	      continue;
	    }
	  perror ("svc_run: - select failed");
	  return;
	case 0:
	  continue;
	default:
	  if (FD_ISSET(xfd, &readfds)) {
	    (*handler)(xfd);
	  }
	  svc_getreqset (&readfds);
	}
    }
}
